/*
 * File : manuf.c
 * Project : WifiScanner (c) 2002 Herv Schauer Consultants
 * Usage : This utility is written for use with IEEE 802.11 adapters based
 * on Intersil's PRISM II chipset (PCMCIA).
 * 
 * Base code was from prismstumbler Jan Fernquist <Jan.B.Fernquist@telia.com>
 * and wlanctl from www.linux-wlan.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: manuf.c,v 1.2 2004/08/20 13:14:08 poggij Exp $
 */


#include <include.h>
#include <src/manuf.h>
#include <src/manuf_table.h>

/*
*/

char *AddMacToManufName(char *AddMac)
{
// TODO : Optimize ME !
  UINT16 i;
  UINT32 MAC;

#ifdef WORDS_BIGENDIAN
  // Not Intel code
  MAC = (UINT32) AddMac;
#else
  // Intel code dependant
  MAC =
      (UINT32) (((AddMac[3])) + ((AddMac[2]) << 8) +
		((AddMac[1]) << 16) + ((AddMac[0]) << 24));
#endif
  for (i = 0; i < SIZE_OF_MANUF_TABLE; i++) {
    if (MAC == manuf_mac_table[i]) {
      break;
    }
  }
  // If we didn't find manuf, we search with a little mask
  if (i == SIZE_OF_MANUF_TABLE) {
#ifdef WORDS_BIGENDIAN
    // Not Intel code
    MAC = (UINT32) (AddMac && 0xFFFFFF00);
#else
    // Intel code dependant
    MAC =
	(UINT32) (((AddMac[2]) << 8) + ((AddMac[1]) << 16) +
		  ((AddMac[0]) << 24));
#endif
    for (i = 0; i < SIZE_OF_MANUF_TABLE; i++) {
      if (MAC == manuf_mac_table[i]) {
	break;
      }
    }

  }
  return ((char *) manuf_name_table[i]);
}

char *AddMacToManufModel(char *AddMac)
{
// TODO : Optimize ME !
  UINT16 i;
  UINT32 MAC;

#ifdef WORDS_BIGENDIAN
  // Not Intel code
  MAC = (UINT32) AddMac;
#else
  // Intel code dependant
  MAC =
      (UINT32) (((AddMac[3])) + ((AddMac[2]) << 8) +
		((AddMac[1]) << 16) + ((AddMac[0]) << 24));
#endif
  for (i = 0; i < SIZE_OF_MANUF_TABLE; i++) {
    if (MAC == manuf_mac_table[i]) {
      break;
    }
  }
  // If we didn't find manuf, we search with a little mask
  if (i == SIZE_OF_MANUF_TABLE) {
#ifdef WORDS_BIGENDIAN
    // Not Intel code
    MAC = (UINT32) (AddMac && 0xFFFFFF00);
#else
    // Intel code dependant
    MAC =
	(UINT32) (((AddMac[2]) << 8) + ((AddMac[1]) << 16) +
		  ((AddMac[0]) << 24));
#endif
    for (i = 0; i < SIZE_OF_MANUF_TABLE; i++) {
      if (MAC == manuf_mac_table[i]) {
	break;
      }
    }

  }
  return ((char *) manuf_model_table[i]);
}
